﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Persistence;

namespace doLogic
{
    public class Clients : PersistentList<Client>
    {
		internal static Clients _Clients = null;
        public static Clients All
        {
            get
            {
				if (_Clients == null)
				{
					_Clients = new Clients();
					_Clients.Load();
				}
                return _Clients;
            }
        }
    }

    [Persistable("Client", "ClientCode", false)]
    public class Client
    {
        public Client() { }

        internal Client(int clientCode)
        {
            this.ClientCode = clientCode;
            Database.Load(this);
        }

        //private Managers _Managers = null;
        //public Managers Managers
        //{
        //    get
        //    {
        //        if (_Managers == null)
        //            _Managers = Managers.For(this);
        //        return _Managers;
        //    }
        //}

        //private Divisions _Divisions = null;
        //public Divisions Divisions
        //{
        //    get
        //    {
        //        if (_Divisions == null)
        //            _Divisions = Divisions.For(this);
        //        return _Divisions;
        //    }
        //}

        //private Locations _Locations = null;
        //public Locations Locations
        //{
        //    get
        //    {
        //        if (_Locations == null)
        //            _Locations = Locations.For(this);
        //        return _Locations;
        //    }
        //}

		public string PhoneNumberFormatted
        {
            get
            {
                return PhoneNumber.ToPhoneFormat();
            }
        }

        public string CallCenterPhoneFormatted
        {
            get
            {
                return CallCenterPhone.ToPhoneFormat();
            }
        }

		public string FaxNumberFormatted
		{
			get
			{
				return FaxNumber.ToPhoneFormat();
			}
		}

        public string ClientLongName { get { return String.Format("{0} ({1})", this.ClientName, this.ClientShortName); } }

        //public void Load() { Database.Load(this); }
        public int Store() { return Database.Store(this); }
        //public bool Delete() { return Database.Delete(this); }

        public int ClientCode { get; set; }
        public string ClientName { get; set; }
        public string ContactFirstName { get; set; }
        public string ContactLastName { get; set; }
        public string BillingAddress { get; set; }
        public string City { get; set; }
        public string State { get; set; }
        public string Zip { get; set; }
        public string ContactTitle { get; set; }
        public string PhoneNumber { get; set; }
        public string Extension { get; set; }
        public string FaxNumber { get; set; }
        public string EmailAddress { get; set; }
        public string Notes { get; set; }
        public string Image { get; set; }
        public string BannerImage { get; set; }
        public string MedCCImage { get; set; }
        public string SmallCCImage { get; set; }
        public string Theme { get; set; }
        public bool Active { get; set; }
        public string URL { get; set; }
        public string ClientFulfillmentDocFolder { get; set; }
        public int DivID { get; set; }
        public bool WPPayType { get; set; }
        public bool WPClass { get; set; }
        public bool WPCategory { get; set; }
        public bool WPUCode { get; set; }
        public string ClientShortName { get; set; }
        public string CallCenterPhone { get; set; }
        public string CallCenterEmail { get; set; }
    }
}


//public static Employee FindEmployee(int empID)
//{
//    Employee employee = null;
//    foreach (Client client in Clients.All)
//    {
//        employee = client.Employees.ItemById(empID);
//        if (employee != null)
//            break;
//    }
//    return employee;
//}

////Employees for the client are lazy-loaded into memory and cached
        //private Employees _Employees = null;
        //internal Employees Employees
        //{
        //    get
        //    {
        //        if (_Employees == null)
        //            _Employees = new Employees(this.ClientCode);
        //        return _Employees;
        //    }
        //}

        //private Employees _AllEmployees = null;
        //public Employees AllEmployees
        //{
        //    get
        //    {
        //        if (_AllEmployees == null)
        //        {
        //            _AllEmployees = new Employees(this.ClientCode);
        //            Database.LoadAll(_AllEmployees, "ForClient");
        //            _Employees = _AllEmployees;
        //        }
        //        return _AllEmployees;
        //    }
        //}

        //public Employee GetEmployee(int empID)
        //{
        //    //see if the employee is already loaded into memory
        //    Employee e = this.Employees.ItemById(empID);
        //    if (e == null)	//pull it from the database
        //    {
        //        e = Employees.Get(empID);
        //        this.Employees.Add(e);
        //        this.Employees.Sort(emp => emp.Last + emp.First);
        //    }
        //    return e;
        //}

        //public Employee GetEmployee(string ssn)
        //{
        //    //see if the employee is already loaded into memory
        //    ssn = ssn.ToNumbersOnly();
        //    Employee e = this.Employees.SingleOrDefault(emp => emp.SSN == ssn);
        //    if (e == null)	//pull it from the database
        //    {
        //        e = Employees.GetBySSN(this.ClientCode, ssn);
        //        this.Employees.Add(e);
        //        this.Employees.Sort(emp => emp.Last + emp.First);
        //    }
        //    return e;
        //}

        //public Employee AddEmployee(string firstName, string lastName, DateTime birthDate)
        //{
        //    Employee employee = new Employee(this.ClientCode, firstName, lastName, birthDate);
        //    this.Employees.Add(employee);
        //    this.Employees.Sort(emp => emp.Last + emp.First);
        //    return employee;
        //}

        //public void MergeAndDelete(Employee toKeep, Employee toMerge, string updatedBy)
        //{
        //    if (toKeep.EmpID == toMerge.EmpID)
        //        throw new ApplicationException("Unable to merge the same employee.  Employee SSN: " + toMerge.SSNFormatted);

        //    using (Connection trans = Database.OpenWithTransaction())
        //    {
        //        foreach (ContactLogItem item in toMerge.ContactLog)
        //        {
        //            item.EmpID = toKeep.EmpID;
        //            item.Notes += String.Format("\r\n\r\nThis conversation was merged from employee ID {0} (SSN: {1}) on {2} at {3}.\r\n", toMerge.EmpID, toMerge.SSNFormatted, DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString());
        //            item.Store(trans);
        //        }

        //        foreach (EmployeeEvent item in toMerge.EmployeeEvents)
        //        {
        //            item.EmpID = toKeep.EmpID;
        //            item.DATA_SOURCE = "merged from employee record " + toMerge.SSNFormatted;
        //            try { item.Store(trans, updatedBy); }
        //            catch (System.Data.ConstraintException) { item.Delete(trans); }
        //            catch (System.Data.SqlClient.SqlException ex) { if (ex.Number == 2601) item.Delete(trans); }
        //        }

        //        EmployeeEvent ee = new EmployeeEvent(toKeep.EmpID, 10, 50, "merged employee record " + toMerge.SSNFormatted, "into employee record " + toKeep.SSNFormatted, "Admin-Created", "Complete", updatedBy);
        //        ee.Store(trans, updatedBy);

        //        EmployeeEventStatus esi = new EmployeeEventStatus(ee, 9, "incorrect SSN records merged", new DateTime(), new DateTime(), 0);
        //        esi.Store(trans);

        //        toMerge.Delete(trans);
        //        _Employees.Remove(toMerge);

        //        toKeep.ClearCache();

        //        trans.Complete();
        //    }
        //}

